unit fs01aef_main;

interface

uses

  fs01aef_lib,

  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.ExtCtrls, Vcl.StdCtrls,
  fs_synmemo, Vcl.Buttons, fs_iclassesrtti, fs_ipascal, fs_iinterpreter,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf,
  FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async,
  FireDAC.Phys, FireDAC.Phys.SQLite, FireDAC.Phys.SQLiteDef,
  FireDAC.Stan.ExprFuncs, FireDAC.VCLUI.Wait, FireDAC.Stan.Param, FireDAC.DatS,
  FireDAC.DApt.Intf, FireDAC.DApt, Data.DB, FireDAC.Comp.DataSet,
  FireDAC.Comp.Client, Vcl.DBCtrls, FireDAC.Phys.SQLiteWrapper.Stat;

type
  TfMain = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    GroupBox1: TGroupBox;
    fsScript1: TfsScript;
    fsPascal1: TfsPascal;
    fsClassesRTTI1: TfsClassesRTTI;
    FDConn: TFDConnection;
    qScr: TFDQuery;
    dsScr: TDataSource;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel3: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Panel4: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label1: TLabel;
    Panel6: TPanel;
    SpeedButton5: TSpeedButton;
    GroupBox2: TGroupBox;
    Splitter1: TSplitter;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    Splitter2: TSplitter;
    Panel9: TPanel;
    Label6: TLabel;
    Panel11: TPanel;
    btnSaveToDB: TSpeedButton;
    SpeedButton9: TSpeedButton;
    Panel5: TPanel;
    Label2: TLabel;
    btnLoadFromDB64: TSpeedButton;
    DBMemo1: TDBMemo;
    DBMemo2: TDBMemo;
    Label5: TLabel;
    Label7: TLabel;
    btnLoadFromDB: TSpeedButton;
    SpeedButton6: TSpeedButton;
    qScrid: TFDAutoIncField;
    qScrfs_script: TWideMemoField;
    qScrfs_script64: TWideMemoField;
    fsSyntaxMemo1: TfsSyntaxMemo;
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FDConnBeforeConnect(Sender: TObject);
    procedure DBMemo1Exit(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FDConnBeforeDisconnect(Sender: TObject);
    procedure btnSaveToDBClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure btnLoadFromDBClick(Sender: TObject);
    procedure btnLoadFromDB64Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fMain: TfMain;

procedure Query_MakePOST(Tbl : TFDQuery);

implementation

{$R *.dfm}


procedure TfMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=true;
  FDConn.Connected:=false;
end;

procedure TfMain.FormCreate(Sender: TObject);
begin
  fsSyntaxMemo1.Parent := Panel8;
  fsSyntaxMemo1.Align:=alClient;
end;

procedure TfMain.FormShow(Sender: TObject);
begin
  qScr.Open;
end;

procedure TfMain.FDConnBeforeConnect(Sender: TObject);
begin
  FDConn.Params.Values['Database'] := ChangeFileExt(ParamStr(0),'.db');
end;

procedure TfMain.FDConnBeforeDisconnect(Sender: TObject);
begin
  Query_MakePOST(qScr);
end;

procedure TfMain.DBMemo1Exit(Sender: TObject);
begin
  Application.ProcessMessages;
  Query_MakePOST(qScr);
end;

procedure TfMain.SpeedButton1Click(Sender: TObject);
begin
  Application.ProcessMessages;
  FS_SaveToFile(ExtractFilePath(ParamStr(0))+'FS_script_UTF8.pas',
                fsSyntaxMemo1.Lines,
                true
               );
end;

procedure TfMain.SpeedButton2Click(Sender: TObject);
Var
  fn:string;
begin
  Application.ProcessMessages;
  fsSyntaxMemo1.Lines.Clear;
  fn:=ExtractFilePath(ParamStr(0))+'FS_script_UTF8.pas';
  if FileExists(fn) then begin
     FS_LoadFromFile(fn,
                     fsSyntaxMemo1.Lines,
                     true
                    );
     fsSyntaxMemo1.UpdateView;
  end
  else begin
     ShowMessage('  : '+#10+fn);
  end;
end;

procedure TfMain.btnLoadFromDB64Click(Sender: TObject);
begin
  Application.ProcessMessages;
  fsSyntaxMemo1.Lines.Clear;
  fsSyntaxMemo1.Lines.Text:=StrBase64_to_Str(qScrfs_script64.AsString);
  fsSyntaxMemo1.UpdateView;
end;

procedure TfMain.btnLoadFromDBClick(Sender: TObject);
begin
  Application.ProcessMessages;
  fsSyntaxMemo1.Lines.Clear;
  fsSyntaxMemo1.Lines.Text:=qScrfs_script.AsString;
  fsSyntaxMemo1.UpdateView;
end;

procedure TfMain.SpeedButton5Click(Sender: TObject);
begin
  Application.ProcessMessages;
  //---------------------
  fsScript1.Clear;
  fsScript1.Lines.Text := fsSyntaxMemo1.Lines.Text;
  fsScript1.Parent := fsGlobalUnit;
  fsScript1.SyntaxType := 'PascalScript';
  //---------------------
  //---------------------
  if fsScript1.Compile then begin
     fsScript1.Execute;
  end
  else begin
     ShowMessage('  : '+fsScript1.ErrorMsg);
  end;
  //---------------------
end;


procedure TfMain.SpeedButton6Click(Sender: TObject);
begin
  qScr.Edit;
  qScrfs_script64.AsString:='';
  qScr.Post;
end;

procedure TfMain.btnSaveToDBClick(Sender: TObject);
begin
  qScr.Delete;
  qScr.Append;
  qScr.Edit;
  qScrfs_script.AsString:=fsSyntaxMemo1.Lines.Text;
  qScrfs_script64.AsString:=Str_to_StrBase64(fsSyntaxMemo1.Lines.Text);
  qScr.Post;
end;

procedure TfMain.SpeedButton9Click(Sender: TObject);
begin
  qScr.Edit;
  qScrfs_script.AsString:='';
  qScr.Post;
end;

procedure Query_MakePOST(Tbl : TFDQuery);
//   ..
begin
  if Assigned(Tbl) then begin
     if Tbl.Active then begin
        TRY
          if (Tbl.State<>dsBrowse) then begin
             Tbl.POST;
          end;
        FINALLY

        END;
     end;
  end;
end;

end.



